# Vald APIs

Vald provides 6 kinds of API for handling vector with Vald cluster.<br>
Vald provide 2 API interface: gRPC and REST API.
Using **gRPC** is preferred for better performance.

## Vald APIs Overview

The APIs overview tables is here:

|    Service     | Description                                                                                                                                       | API NAMES                                                                                                                                                                                                                                                                                                                                                                                      | LINK                                 |
| :------------: | :------------------------------------------------------------------------------------------------------------------------------------------------ | :--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | :----------------------------------- |
| Insert Service | Insert new vector(s) into the Vald Agent Pods.                                                                                                    | [Insert](../api/insert.md#insert-rpc)<br>[StreamInsert](../api/insert.md#streaminsert-rpc)<br>[MultiInsert](../api/insert.md#multiinsert-rpc)                                                                                                                                                                                                                                                  | [Vald Insert APIs](../api/insert.md) |
| Update Service | Update the exists vector(s) in the Vald Agent Pods.                                                                                               | [Update](../api/update.md#update-rpc)<br>[StreamUpdate](../api/update.md#streamupdate-rpc)<br>[MultiUpdate](../api/update.md#multiupdate-rpc)                                                                                                                                                                                                                                                  | [Vald Update APIs](../api/update.md) |
| Upsert Service | Update the exists vector(s) in the Vald Agent Pods or Insert new vector(s) into the Vald Agent Pods if the vector is not exists.                  | [Upsert](../api/upsert.md#upsert-rpc)<br>[StreamUpsert](../api/upsert.md#streamupsert-rpc)<br>[MultiUpdate](../api/upsert.md#multiupsert-rpc)                                                                                                                                                                                                                                                  | [Vald Upsert APIs](../api/upsert.md) |
| Search Service | Search nearest neighbor vectors using query (vectors or IDs).<br>There are 2 types of Search methods: Search (means ANN Search) and LinearSearch. | [Search](../api/search.md#search-rpc)<br>[SearchByID](../api/search.md#searchbyid-rpc)<br>[StreamSearch](../api/search.md#streamsearch-rpc)<br>[StreamSearchByID](../api/search.md#streamsearchbyid-rpc)<br>[MultiSearch](../api/search.md#multisearch-rpc)<br>[MultiSearchByID](../api/search.md#multisearchbyid-rpc)<br>[LinearSearch](../api/search.md#linearsearch-rpc)<br>[LinearSearchByID](../api/search.md#linearsearchbyid-rpc)<br>[StreamLinearSearch](../api/search.md#streamlinearsearch-rpc)<br>[StreamLinearSearchByID](../api/search.md#streamlinearsearchbyid-rpc)<br>[MultiLinearSearch](../api/search.md#multilinearsearch-rpc)<br>[MultiLinearSearchByID](../api/search.md#multilinearsearchbyid-rpc)                                                                         | [Vald Search APIs](../api/search.md) |
| Remove Service | Remove the exists vector(s) from the Vald Agent Pods.                                                                                             | [Remove](../api/remove.md#remove-rpc)<br>[StreamRemove](../api/remove.md#streamremove-rpc)<br>[MultiRemove](../api/remove.md#multiremove-rpc)                                                                                                                                                                                                                                                  | [Vald Remove APIs](../api/remove.md) |
| Object Service | Get information of vector(s) indexed into the Vald Agent Pods.                                                                                    | [Exists](../api/object.md#exists-rpc)<br>[GetObject](../api/object.md#getobject-rpc)<br>[StreamGetObject](../api/object.md#streamgetobject-rpc)                                                                                                                                                                                                                                                | [Vald Object APIs](../api/object.md) |

<br>
<br>
<div class="notice">
linear search services are available in v1.4.0 and later version.
</div>

## Client Library

Vald provides [the public client libraries](../user-guides/sdks.md) for some programming languages.
If there is no client library for your favorite programming language, please refer to [build proto docs](../api/build_proto.md) to build on yourself.
